
#pragma used+
sfrb TWBR=0;
sfrb TWSR=1;
sfrb TWAR=2;
sfrb TWDR=3;
sfrb ADCL=4;
sfrb ADCH=5;
sfrw ADCW=4;      
sfrb ADCSRA=6;
sfrb ADMUX=7;
sfrb ACSR=8;
sfrb UBRRL=9;
sfrb UCSRB=0xa;
sfrb UCSRA=0xb;
sfrb UDR=0xc;
sfrb SPCR=0xd;
sfrb SPSR=0xe;
sfrb SPDR=0xf;
sfrb PIND=0x10;
sfrb DDRD=0x11;
sfrb PORTD=0x12;
sfrb PINC=0x13;
sfrb DDRC=0x14;
sfrb PORTC=0x15;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb EECR=0x1c;
sfrb EEDR=0x1d;
sfrb EEARL=0x1e;
sfrb EEARH=0x1f;
sfrw EEAR=0x1e;   
sfrb UBRRH=0x20;
sfrb UCSRC=0X20;
sfrb WDTCR=0x21;
sfrb ASSR=0x22;
sfrb OCR2=0x23;
sfrb TCNT2=0x24;
sfrb TCCR2=0x25;
sfrb ICR1L=0x26;
sfrb ICR1H=0x27;
sfrw ICR1=0x26;   
sfrb OCR1BL=0x28;
sfrb OCR1BH=0x29;
sfrw OCR1B=0x28;  
sfrb OCR1AL=0x2a;
sfrb OCR1AH=0x2b;
sfrw OCR1A=0x2a;  
sfrb TCNT1L=0x2c;
sfrb TCNT1H=0x2d;
sfrw TCNT1=0x2c;  
sfrb TCCR1B=0x2e;
sfrb TCCR1A=0x2f;
sfrb SFIOR=0x30;
sfrb OSCCAL=0x31;
sfrb TCNT0=0x32;
sfrb TCCR0=0x33;
sfrb MCUCSR=0x34;
sfrb MCUCR=0x35;
sfrb TWCR=0x36;
sfrb SPMCR=0x37;
sfrb TIFR=0x38;
sfrb TIMSK=0x39;
sfrb GIFR=0x3a;
sfrb GICR=0x3b;
sfrb SPL=0x3d;
sfrb SPH=0x3e;
sfrb SREG=0x3f;
#pragma used-

#asm
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
#endasm

typedef char *va_list;

#pragma used+

char getchar(void);
void putchar(char c);
void puts(char *str);
void putsf(char flash *str);
int printf(char flash *fmtstr,...);
int sprintf(char *str, char flash *fmtstr,...);
int vprintf(char flash * fmtstr, va_list argptr);
int vsprintf(char *str, char flash * fmtstr, va_list argptr);

char *gets(char *str,unsigned int len);
int snprintf(char *str, unsigned int size, char flash *fmtstr,...);
int vsnprintf(char *str, unsigned int size, char flash * fmtstr, va_list argptr);

int scanf(char flash *fmtstr,...);
int sscanf(char *str, char flash *fmtstr,...);

#pragma used-

#pragma library stdio.lib

#pragma used+

void delay_us(unsigned int n);
void delay_ms(unsigned int n);

#pragma used-

#pragma used+
void sleep_enable(void);
void sleep_disable(void);
void idle(void);

void powerdown(void);

void powersave(void);

void standby(void);

void extended_standby(void);
#pragma used-

#pragma library sleep.lib

unsigned char ledState[12  *10  ];  

enum { LED_OFF = 0, LED_ON, LED_DIM }; 

unsigned char seconds = 0;             
unsigned char minutes = 0;             
unsigned char hours = 0;               
bit bSound = 0;                        

flash unsigned char ledHours[12] =     
{
50, 81, 103, 105, 107, 89, 59, 29, 7, 5, 3, 21
};

flash unsigned char decimals[] =
{                   
0x1F, 0x11, 0x1F,   
0x04, 0x02, 0x1F,   
0x1D, 0x15, 0x17,   
0x15, 0x15, 0x1F,   
0x07, 0x04, 0x1F,   
0x17, 0x15, 0x1D,   
0x1F, 0x15, 0x1D,   
0x01, 0x01, 0x1F,   
0x1F, 0x15, 0x1F,   
0x17, 0x15, 0x1F    
};

void clearScreen(void)
{
unsigned char i;

for(i = 0; i < (12  *10  ); i++)
{
ledState[i] = LED_OFF;
}
}

void waitUntilKeypressed(void)
{
while(!(PIND.3 == 0));
delay_ms(20);
}

void waitUntilKeyreleased(void)
{
while((PIND.3 == 0));
delay_ms(20);
}

unsigned char keyPressed(void)
{
unsigned char result = 0;

if((PIND.3 == 0))
result = 1;
delay_ms(20);

return result;
}

interrupt [10] void timer0_ovf_isr(void)
{
static unsigned char count = 0;
static unsigned char framecount = 0;
static unsigned int blinkcounter = 0;
static bit bBlinkOn = 1;
bit bLed;
unsigned char state, i, value1, value2, value3;
unsigned char *pState;

blinkcounter++;
if(blinkcounter == 1000)
{
bBlinkOn = ~bBlinkOn;
blinkcounter = 0;
}

count++;
if(count >= 12)
{
count = 0;
PORTB.4 = 0;
framecount++;
}
else
{
PORTB.4 = 1;
}
PORTB.3 = 1;
PORTB.3 = 0;

pState = &ledState[count*10  ];

value1 = 0;
for(i = 0; i < 4; i++)
{
value1 >>= 1;
state = (*pState) & (~0x80                  );
bLed = 0;
if(state == LED_ON)
{
bLed = 1;
}
else if(state == LED_DIM)
{
if((framecount & 0x03) == 0x03)
bLed = 1;
}
if((*pState) & 0x80                  )
{
if(!bBlinkOn)
bLed = 0;
}
if(bLed)
{
value1 |= 0x08;
}
pState++;
}

value2 = 0;
for(i = 0; i < 4; i++)
{
value2 >>= 1;
state = (*pState) & (~0x80                  );
bLed = 0;
if(state == LED_ON)
{
bLed = 1;
}
else if(state == LED_DIM)
{
if((framecount & 0x03) == 0x03)
bLed = 1;
}
if((*pState) & 0x80                  )
{
if(!bBlinkOn)
bLed = 0;
}
if(bLed)
{
value2 |= 0x80;
}
pState++;
}

value3 = 0;
for(i = 0; i < 2; i++)
{
value3 >>= 1;
state = (*pState) & (~0x80                  );
bLed = 0;
if(state == LED_ON)
{
bLed = 1;
}
else if(state == LED_DIM)
{
if((framecount & 0x03) == 0x03)
bLed = 1;
}
if((*pState) & 0x80                  )
{
if(!bBlinkOn)
bLed = 0;
}
if(bLed)
{
value3 |= 0x02;
}
pState++;
}

PORTC &= (~0x0F);
PORTD &= (~0xF0);
PORTB &= (~0x03);
PORTB.2 = 1;
PORTB.2 = 0;
PORTC |= (value1);
PORTD |= (value2);
PORTB |= (value3);

}

void initTimer0(void)
{

TCCR0=0x02;
TCNT0=0x00;

TIMSK |= 0x01;
}

interrupt [5] void timer2_ovf_isr(void)
{
if(seconds < 59)
{
seconds++;
}
else
{
seconds = 0;
if(minutes < 59)
minutes++;
else
{
minutes = 0;
if(hours < 23)
hours++;
else
hours = 0;
}
if((minutes % 15) == 0)
{                
bSound = 1;
}
}
}

void initTimer2(void)
{

ASSR=0x08;
TCCR2=0x05;
TCNT2=0x00;
OCR2=0x00;

TIMSK |= 0x40;
}

void stopTimer2(void)
{
TCCR2=0x00;
TCNT2=0x00;
}

interrupt [2] void ext_int0_isr(void)
{
}

void initInt0(void)
{

GICR &= (~0x40);   
MCUCR &= 0xFC;
GIFR=0x40;
}

void init(void)
{
PORTB = 0;
DDRB = 0x1F;
PORTC = 0;
DDRC = 0x0F;
PORTD = 0;
DDRD = 0xF4;
PORTD.3 = 1;
PORTD.1     = 0;
DDRD.1 = 1;

ACSR=0x80;
SFIOR=0x00;
}

void initADC(void)
{

ADMUX=0x00 & 0xff;
ADCSRA=0x86;
}

unsigned int read_adc(unsigned char adc_input)
{
ADMUX=adc_input | (0x00 & 0xff);

delay_us(10);

ADCSRA|=0x40;

while ((ADCSRA & 0x10)==0);
ADCSRA|=0x10;

return ADCW;
}

unsigned char selectMinutes1(void)
{
unsigned char x;                        

x = 9 - (read_adc(7) / (1023/10 + 1));

return(x);
}

unsigned char selectMinutes10(void)
{
unsigned char x;                        

x = (read_adc(6) / (1023/6 + 1));

return(x);
}

unsigned char selectHour(void)
{
unsigned char x;                        

x = 11 - (read_adc(7) / (1023/12 + 1));

return(x);
}

void initI2C(void)
{

TWBR=0x98;

TWAR=0x00;

TWCR=0x44;
TWSR=0x00;   
}

void disableI2C(void)
{
TWCR=0x00;
TWSR=0x00;
}

void i2cStart(void)
{
TWCR = (1<<7) | (1<<5) | (1<<2);

while (!(TWCR & (1<<7)));

}

void i2cStop(void)
{
TWCR = (1<<7) | (1<<4) | (1<<2);
}

void i2cSend(unsigned char c)
{
TWDR = c;
TWCR = (1<<7) | (1<<2);

while (!(TWCR & (1<<7)));
}

void showDecimal(unsigned char d, unsigned char state)
{
unsigned char i, j, k, value, col, divisor, pattern;

col = 2;                               
divisor = 10;
for(k = 0; k < 2; k++)
{
value = d / divisor;
for(j = 0; j < 3; j++)
{      
pattern = decimals[value*3 + j];
for(i = 0; i < 5; i++)
{                            
if( pattern & (0x01 << i) )
ledState[col*10   + 3 + i] = state;
else
ledState[col*10   + 3 + i] = LED_OFF;
}           
col++;
}        
col++;
d = d % divisor;
divisor = divisor / 10;
}

}

void showClock(unsigned char cShowMinutes, unsigned char cDecimalState)
{
unsigned char i, cValue, cHour, state;

if(cShowMinutes)
cValue = minutes;
else
cValue = seconds;

cHour = hours;
if(cHour >= 12)
cHour -= 12;      

for(i = 0; i < 12; i++)
{
if(i == cHour)
state = LED_ON;
else
state = LED_DIM;
ledState[ledHours[i]] = state;
}      
showDecimal(cValue, cDecimalState);   

}

void main(void)
{
unsigned char d, d10, index=0, i, bongCounter=0;
unsigned int iCountSCL;
bit bShowMinutes = 1;
bit bCheckSoundEnd = 0;

init();
initTimer0();
initTimer2();
initADC();
initInt0();

clearScreen();

#asm("sei")      

while(1)
{
if((PIND.3 == 0))
{
delay_ms(20);         
i = 50;         
while( keyPressed() && (i != 0) )   
{
i--;
}
if(i == 0)
{  
stopTimer2();
showClock(1, LED_OFF);
waitUntilKeyreleased();

do
{
d = selectHour();        
hours = d;
showClock(1, LED_OFF);
}
while(!keyPressed());
waitUntilKeyreleased();

do
{
d10 = selectMinutes10(); 
d = selectMinutes1();    
minutes = d10*10 + d;
showClock(1, LED_ON);
}
while(!keyPressed());
waitUntilKeyreleased();

seconds = 0;
showClock(0, LED_DIM);
bShowMinutes = 0;           
waitUntilKeypressed();
waitUntilKeyreleased();
initTimer2();
}                              
else
{  
bShowMinutes = ~bShowMinutes;
}
}

showClock(bShowMinutes, LED_DIM); 

if(bSound)                 
{     
index = minutes / 15;   
if(index == 0)
{
index = 4;
}
bSound = 0;
if(index == 4)          
{
bongCounter = hours;
if(bongCounter > 12)
bongCounter -= 12;
if(bongCounter == 0)
bongCounter = 12;
}
}

if(index)           
{        
PORTC.5     = 1;       
PORTC.4     = 1;

(PORTD.1     = 1);

delay_ms(100);
initI2C();
i2cStart();
i2cSend(0xAA);   
i2cSend(index);  
i2cStop();

disableI2C();

delay_ms(50);
index = 0;
iCountSCL = 0;
bCheckSoundEnd = 1;
}

if(bCheckSoundEnd)
{                   
if(PINC.5)
{
iCountSCL++;
}
else
{
iCountSCL = 0;
}             

if(iCountSCL >= 1000)
{
bCheckSoundEnd = 0;

if(bongCounter)
{                
index = 5;       
bongCounter--;
}
else
{
PORTC.5     = 0;       
PORTC.4     = 0;

(PORTD.1     = 0);   
} 
}
}

}   
}
